



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>局部敏感哈希 Kernelized Locality-Sensitive Hashing Page</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">局部敏感哈希 Kernelized Locality-Sensitive Hashing Page</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 09:32:13 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Kernelized Locality-Sensitive Hashing Page</h1>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/ucb_seal.png" />&nbsp;<img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/ut_seal.gif" /></div>
<h4><a href="http://www.eecs.berkeley.edu/~kulis" rel="external nofollow noreferrer">Brian Kulis</a>&nbsp;(1) and&nbsp;<a href="http://www.cs.utexas.edu/~grauman" rel="external nofollow noreferrer">Kristen Grauman</a>&nbsp;(2)<br />(1) UC Berkeley EECS and ICSI, Berkeley, CA<br />(2) University of Texas, Department of Computer Sciences, Austin, TX</h4>
<hr />
<h2>Introduction</h2>
<hr />
<blockquote><p>Fast indexing and search for large databases is critical to content-based image and video retrieval---particularly given the ever-increasing availability of visual data in a variety of interesting domains, such as scientific image data, community photo collections on the Web, news photo collections, or surveillance archives. The most basic but essential task in image search is the "nearest neighbor" problem: to take a query image and accurately find the examples that are most similar to it within a large database. A naive solution to finding neighbors entails searching over all n database items and sorting them according to their similarity to the query, but this becomes prohibitively expensive when n is large or when the individual similarity function evaluations are expensive to compute. For vision applications, this complexity is amplified by the fact that often the most effective representations are high-dimensional or structured, and best known distance functions can require considerable computation to compare a single pair of objects.</p>
<p>To make large-scale search practical, vision researchers have recently explored approximate similarity search techniques, most notably locality-sensitive hashing (Indyk and Motwani 1998, Charikar 2002), where a predictable loss in accuracy is sacrificed in order to allow fast queries even for high-dimensional inputs. In spite of hashing's success for visual similarity search tasks, existing techniques have some important restrictions. Current methods generally assume that the data to be hashed comes from a multidimensional vector space, and require that the underlying embedding of the data be explicitly known and computable. For example, LSH relies on random projections with input vectors; spectral hashing (Weiss et al. NIPS 2008) assumes vectors with a known probability distribution.</p>
<p>This is a problematic limitation, given that many recent successful vision results employ kernel functions for which the underlying embedding is known only implicitly (i.e., only the kernel function is computable). It is thus far impossible to apply LSH and its variants to search data with a number of powerful kernels---including many kernels designed specifically for image comparisons, as well as some basic well-used functions like a Gaussian RBF. Further, since visual representations are often most naturally encoded with structured inputs (e.g., sets, graphs, trees), the lack of fast search methods with performance guarantees for flexible kernels is inconvenient.</p>
<p><strong>In this work, we present an LSH-based technique for performing fast similarity searches over arbitrary kernel functions.</strong>&nbsp;The problem is as follows: given a kernel function and a database of n objects, how can we quickly find the most similar item to a query object in terms of the kernel function? Like standard LSH, our hash functions involve computing random projections; however, unlike standard LSH, these random projections are constructed using only the kernel function and a sparse set of examples from the database itself. Our main technical contribution is to formulate the random projections necessary for LSH in kernel space. Our construction relies on an appropriate use of the central limit theorem, which allows us to approximate a random vector using items from our database. The resulting scheme, which we call kernelized LSH (KLSH), generalizes LSH to scenarios when the feature space embeddings are either unknown or incomputable.</p></blockquote>
<h2>Method</h2>
<hr />
<blockquote><div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/lshfig.png" /></div>
<p>The main idea behind our approach is to construct a random hyperplane hash function, as in standard LSH, but to perform computations purely in kernel space. The construction is based on the central limit theorem, which will compute an approximate random vector using items from the database. The central limit theorem states that, under very mild conditions, the mean of a set of objects from some underlying distribution will be Gaussian distributed in the limit as more objects are included in the set. Since for LSH we require a random vector from a particular Gaussian distribution---that of a zero-mean, identity covariance Gaussian---we can use the central limit theorem, along with an appropriate mean-shift and whitening, to form an approximate random vector from a unit-mean, identity covariance Gaussian. By performing this construction appropriately, the algorithm can be applied entirely in kernel space, and can also be applied efficiently over very large data sets.</p>
<p>Once we have computed the hash functions, we use standard LSH techniques to retrieve nearest neighbors of a query to the database in sublinear time. In particular, we employ the method of Charikar for obtaining a small set of candidate approximate nearest neighbors, and then these are sorted using the kernel function to yield a list of hashed nearest neighbors.</p>
<p>There are some limitations to the method. The random vector constructed by the KLSH routine is only approximately random; general bounds on the central limit theorem are unknown, so it is not clear how many database objects are required to get a sufficiently random vector for hashing. Further, we implicitly assume that the objects from the database selected to form the random vectors span the subspace from which the queries are drawn. That said, in practice the method is robust to the number of database objects chosen for the construction of the random vectors, and behaves comparably to standard LSH on non-kernelized data.</p></blockquote>
<h2>Experimental Results</h2>
<hr />
<blockquote><p><strong>80 Million Tiny Images.</strong>&nbsp;We ran KLSH over the 80 million images in the Tiny Image data set. We used the extracted Gist features from these images, and applied a nearest neighbor search on top of a Gaussian kernel.</p>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/queries3.jpg" /></div>
<p>The top left image in each set is the query. The remainder of the top row shows the top nearest neighbor using a linear scan (with the Gaussian kernel) and the second row shows the nearest neighbor using KLSH. Note that, with this data set, the hashing technique searched less than 1 percent of the database, and nearest neighbors were extracted in approximately .57 seconds (versus 45 seconds for a linear scan). Typically the hashing results appear qualitatively similar to (or match exactly) the linear scan results.</p>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/overlap.png" /></div>
<p>We can see quantitatively how the results of the nearest neighbors extracted from KLSH compare to the linear scan nearest neighbors in the above plot. It shows, for 10, 20, and 30 hashing nearest neighbors, how many linear scan nearest neighbors are required to cover the hashing nearest neighbors.</p>
<p><strong>Flickr Scene Recognition.</strong>&nbsp;We performed a similar experiment with a set of Flickr images containing tourist photos from a set of landmarks. Here, we applied a chi-squared kernel on top of SIFT features for the nearest neighbor search.&nbsp;<strong>Note that these results did not appear in the conference paper.</strong></p>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/flickr_set1.jpg" /><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/flickr_set2.jpg" /></div>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/flickr_chisq.jpg" /></div>
<p>We can also measure how the accuracy of a k-nearest neighbor classifier with KLSH approaches the accuracy of a linear scan k-NN classifier on this data set. The above plot shows that, as epsilon decreases, the hashing accuracy approaches the linear scan accuracy.</p>
<p><strong>Object Recognition on Caltech-101.</strong>&nbsp;We applied our method on the Caltech-101 for object recognition, as there have been several recent kernel functions for images that have shown very good performance for object recognition, but have unknown or very complex featureembeddings. This data set also allowed us to test how changes in parameters affect hashing results.</p>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/caltech_hash_numbits.png" />&nbsp;<img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/caltech_hash_epsilon.png" /></div>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/caltech_hash_ell.png" />&nbsp;<img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/caltech_hash_t.png" /></div>
<p>The parameters p, t, and the number of hash bits only affect hashing accuracy marginally. The main parameter of interest is epsilon, a parameter from standard LSH which trades off speed for accuracy.</p>
<p><strong>Local Patch Indexing with the Photo Tourism Data Set.</strong>&nbsp;Finally, we applied KLSH over a data set of 100,000 image patches from the Photo Tourism data set. We compared a standard Euclidean distance function (linear scan and hashing) with a learned kernel (linear scan and hashing). The particular learned kernel we used has no simple, explicit feature embedding (see the paper for details) but the linear scan retrieval results are significantly better than the baseline Euclidean distance, thus providing another example where KLSH is useful for retrieval. The results indicate that the hashing schemes do not degrade retrieval performance considerably on this data.</p>
<div><img referrerpolicy="no-referrer"src="http://web.cse.ohio-state.edu/~kulis/klsh/patch_klsh.png" /></div>
<p><strong>Summary.</strong>&nbsp;We have shown that hashing can be performed over arbitrary kernels to yield significant speed-ups for similarity searches with little loss in accuracy. In experiments, we have applied KLSH over several kernels, and over several domains:</p>
<ul><li>Gaussian kernel (Tiny Images)</li>
<li>Chi-squared kernel (Flickr)</li>
<li>Correspondence kernel (Caltech-101)</li>
<li>Learned kernel (Photo Tourism)</li></ul></blockquote>
<h2>Code</h2>
<hr />
<blockquote><p>The code is available&nbsp;<a href="http://web.cse.ohio-state.edu/~kulis/klsh/klsh_code.tar.gz" rel="external nofollow noreferrer">here.</a>&nbsp;NOTE: the code was updated July 5, 2010 and September 23, 2010 to correct bugs in createHashTable.m. Please use the most recent version.</p></blockquote>
<h2>Paper</h2>
<hr />
<blockquote><ul><li>Kernelized Locality-Sensitive Hashing for Scalable Image Search<br />Brian Kulis &amp; Kristen Grauman<br />In&nbsp;<em>Proc. 12th International Conference on Computer Vision (ICCV)</em>, 2009.<br />[<a href="http://web.cse.ohio-state.edu/~kulis/pubs/iccv_klsh.pdf" rel="external nofollow noreferrer">pdf</a>]</p>
<p><strong>Also see the following related papers, which apply LSH to learned Mahalanobis metrics:</strong></p></li>
<li>Fast Similarity Search for Learned Metrics<br />Brian Kulis, Prateek Jain, &amp; Kristen Grauman<br /><em>IEEE Transactions on Pattern Analysis and Machine Intelligence</em>, vol. 31, no. 12, pp. 2143--2157, 2009.<br />[<a href="http://web.cse.ohio-state.edu/~kulis/pubs/pami_fastsearch.pdf" rel="external nofollow noreferrer">pdf</a>]</li>
<li>Fast Image Search for Learned Metrics<br />Prateek Jain, Brian Kulis, &amp; Kristen Grauman<br />In.&nbsp;<em>Proc. IEEE Conference on Computer Vision and Pattern Recognition (CVPR)</em>, 2008.<br />[<a href="http://web.cse.ohio-state.edu/~kulis/pubs/cvpr_fastsearch.pdf" rel="external nofollow noreferrer">pdf</a>]</li>
<li>from:&nbsp;http://web.cse.ohio-state.edu/~kulis/klsh/klsh.htm</li></ul></blockquote>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/jqdg0zxq.html">Http协议的常见参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7vy21q.html">CodeForceS&num;276-A</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ezrwm8.html">C&num; 线程基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0o71q.html">node&period;js安装方法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w01o3q.html">20140213-想念是while里的死循环</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k12zd59.html">《JavaScript高级程序设计》 读书笔记（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvn5zyq.html">cursor&colon;hand与cursor&colon;pointer的区别介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojdoeeq.html">Ugly Problem</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jxzno8.html">Image File Execution Options&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgy61m8.html">C&plus;&plus;的封装性</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1re3dq.html">【zzulioj 2127】 tmk射气球</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pyvkn8.html">编写自己的Nmap（NSE）脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkyymd8.html">Codeforces&lowbar;499C&colon;Crazy Town（计算几何）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kyz369.html">SpringMVC（一）--基础、REST、&commat;RequestParam、POST请求乱码等</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj670j8.html">&lbrack;LeetCode&rsqb; Second Minimum Node In a Binary Tree 二叉树中第二小的结点</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdl2049.html">2018-2019-2 20165235《网络对抗技术》Exp2 后门原理与实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rzorz8.html">Django学习笔记之视图高级-CSV文件生成</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1k7rg9.html">ASP&period;NET Web API 框架研究 Web Host模式路由及将请求转出到消息处理管道</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p7eejq.html">Linux 查看网卡流量的几个方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkl4018.html">ubuntu 安装node&period;js</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/963g0en9.html">2018 ACM-ICPC&comma; Syrian Collegiate Programming Contest  F - Pretests   SOS dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppepjz9.html">centos7&plus;python3&period;6&plus;nginx&plus;uwsgi&plus;django2的搭建笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql171ye9.html">MongoDB入门教程一［文档与集合］</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kvxm3q.html">Python实现代码行数统计工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpk3n49.html">imageio 载入 Buffer 格式的图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em251k9.html">&lbrack;js&rsqb;面向对象编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kvm33q.html">Spring Boot使用Log4j Implemented Over SLF4J生成日志并在控制台打印</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gpk5k79.html">MongoDB基本方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppe7ok9.html">hdu 2197 推公式</a>
			</li>
						<li><a href="https://www.batexi.com/a/902l4gmq.html">dll文件反编译，c&num;、vb动态库反编译</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
